agentSystem = new NetworkNodeAgentSystem

For NetworkNodeAgent in iAgents:
	agentSystem.Add(NetworkNodeAgent)

AgentSystems.Add(agentSystem)

For agentSystem in AgentSystems:
	agentSystem.PreExecute():
		For NetworkNodeAgent in agentSystem:
			NetworkNodeAgent.PreExecute():
				NewValue = 0.0
				NewCustomData = CustomData #shallow copy

For agentSystem in AgentSystems:
	agentSystem.Execute():
		For NetworkNodeAgent in agentSystem:
			NetworkNodeAgent.Execute():
				For Behavior in NetworkNodeAgent.Behaviors:
					# newValue will be what is left after the some amount has been diffused into the neighbors
					newValue = NetworkNodeAgent.CustomData["Value"] * (1.0 - DiffusionRate);
					newValue += contributionFromNeighbors
	            	# assign newValue to NewCustomData
	            	NewCustomData.Add("Value", newValue)

For agentSystem in AgentSystems:
	agentSystem.PostExecute():
		For NetworkNodeAgent in agentSystem:
			NetworkNodeAgent.PostExecute():
				CustomData = new Dictionary(NewCustomData) #shallow copy
				Value = NewValue
